/*******************************************************************

Copyright (c) 2004 Open Mobile Alliance, Ltd.  All Rights Reserved.

This software is made available under the usage and distribution terms 
covered by the Common Public License 1.0 and by using this software you
are bound by the terms and conditions of the same.

EXCEPT AS EXPRESSLY SET FORTH IN THE COMMON PUBLIC LICENSE,
THIS PROGRAM IS PROVIDED ON AN "AS IS" BASIS, 
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT LIMITATION, 
ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, 
MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
   
Each recipient is solely responsible for determining the 
appropriateness of using and distributing this program and assumes 
all risks associated with its exercise of rights under the Common 
Public License, including but not limited to the risks and 
costs of program errors, compliance with applicable laws, 
damage to or loss of data, programs or equipment, and 
unavailability or interruption of operations.

********************************************************************/

#ifndef _SCTS_DMACCOUNT_H
#define _SCTS_DMACCOUNT_H

#include "SctsDevManT&D.h"

class SctsDMAccount;


/******************************************************************
SctsDMAccount Class, support DM 1.2 DMAcc node. 
******************************************************************/

class SctsDMAccount
{
public:
    SctsDMAccount(SctsDMTree *_tree, SctsDMNode *_dmAcc, const char *_dmAccPath = 0);
    const char * GetPath() const; 
    const char * GetSubAppAddr() const;
    const char * GetSubPort() const;
    const char * GetSubAppAuthClient() const;
    const char * GetSubAppAuthServer() const;
    const char * GetSubToConRef() const;
    bool IsDMAcc() const { return verify; }

private:

    typedef SctsDMTree::SctsDMNodePtrVec SctsDMNodePtrVec;

    std::string nodePath;
    std::string subAppAddr;
    std::string subPort;
    std::string subAppAuthClient;
    std::string subAppAuthServer;
    std::string subToConRef;
    bool verify;
};

#endif